// my.cpp : Defines the entry point for the console application.
//
#include "MyStream.h"
#include "math.h"
#include <time.h>
using namespace std;

typedef bool BFII(int, int);
typedef bool BFCC(char*, char*);
bool fsiia(int, int);
bool fsiib(int, int);
bool fscca(char*, char*);
bool fsccb(char*, char*);
int fout(int* arr, int N, char* comment, int wd1, int wd2);
int fout(char* arr[], int N, char* comment, int wd1, int wd2);
int fout(int* ia, char* arr[], int N, char* comment, int wd1, int wd2);
int srt(int* arr, int N, BFII f);
int srt(char* arr[], int N, BFCC f);
int srt(int* ia, char* arr[], int N, BFII f);
char* nam[10]={"", "", "", "", "", "", "", "", "", ""};
char* name[10]={"", "", "", "", "", "", "", "", "", ""};
char* names[10]={"", "", "", "", "", "", "", "", "", ""};

int main()
{  
  myofs.open("protocol.txt");
  myofs << setiosflags(ios::fixed) << setiosflags(ios::right) << setw(10);
  {
  myofs << "eam 123,   . 18  2008 ." << endl; 
  myofs << "  3-13.  " << endl << endl; 
  }
  {
    myofs << " 1.    ." << endl;
    const int N=128; int wd=3;
    int* nn = new int[N];
    for(int n=0; n<N; n++) nn[n]=rand()%64;
    myofs << " " << endl;
    for(int n=0; n<N; n++){
      myofs << " [" << setw(wd) << n << "]=" << setw(4) << nn[n];
      if((n+1)%8==0) myofs << endl;
    }
    myofs << endl;
    int tmp;
    for(int n=0; n<N-1; n++) 
      for(int m=n+1; m<N; m++){
        if(nn[n]<nn[m])continue;
        tmp=nn[n];
        nn[n]=nn[m];
        nn[m]=tmp;
      }
    myofs << " " << endl;
    for(int n=0; n<N; n++){
      myofs << " [" << setw(wd) << n << "]=" << setw(4) << nn[n];
      if((n+1)%8==0) myofs << endl;
    }
    myofs << endl;
    delete[] nn;
  }
  {
    myofs << " 2.   ." << endl;
    const int N=128; int wd=3;
    int* nn = new int[N];
    for(int n=0; n<N; n++) nn[n]=rand()%64;
    fout(nn, N, " ", 3, 4);
    srt(nn, N, fsiia);
    fout(nn, N, " ", 3, 4);
    srt(nn, N, fsiib);
    fout(nn, N, "-  ", 3, 4);
    delete[] nn;
  }
  {
    myofs << " 3.    ." << endl;
    const int N=16; int wd=3, n1, n2, n3;
    int* nn = new int[N];
    char* txt[N];
    char buf[128];
    for(int n=0; n<N; n++){
      strcpy(buf, nam[rand()%10]);
      strcat(buf, " ");
      strcat(buf, name[rand()%10]);
      strcat(buf, " ");
      strcat(buf, names[rand()%10]);
      int k = 1 + strlen(buf);
      txt[n] = new char[k];
      strcpy(txt[n], buf);
    }
    for(int n=0; n<N; n++) nn[n]=n;
    for(int n=0; n<1000; n++){
      n1=rand()%N;
      n2=rand()%N;
      n3=nn[n1]; nn[n1]=nn[n2]; nn[n2]=n3;
    }
    fout(nn, txt, N, " ", 3, 4);
    srt(nn, txt, N, fsiia);
    fout(nn, txt, N, " ", 3, 4);
    delete[] nn;
    for(int n=0; n<N; n++) delete[] txt[n];
  }
  {
    myofs << endl << " 4.   ." << endl;
    const int N=64; 
    char* txt[N];
    char buf[128];
    for(int n=0; n<N; n++){
      int k = 1 + rand()%8;
      txt[n] = new char[k+1];
      for(int j=0; j<k; j++)
        buf[j]=char(65+rand()%16);
      buf[k]='\0';
      strcpy(txt[n], buf);
    }
    fout(txt, N, " ", 12, 72);
    srt(txt, N, fscca);
    fout(txt, N, " ", 3, 72);
    srt(txt, N, fsccb);
    fout(txt, N, "-  ", 3, 72);
    for(int n=0; n<N; n++) delete[] txt[n];
  }
  myofs.close();
  return 0;
}

int fout(int* arr, int N, char* comment, int wd1=2, int wd2=4)
{
  int addl=true;
  myofs << comment << endl;
  for(int n=0; n<N; n++){
    myofs << " [" << setw(wd1) << n << "]=" << setw(wd2) << arr[n];
    addl=true;
    if((n+1)%8==0){ myofs << endl; addl=false; }
  }
  if(addl) myofs << endl;
  return 0;
}
int fout(char* arr[], int N, char* comment, int wd1=12, int wd2=128)
{
  int addl=true;
  int count=0;
  myofs << endl << comment << endl;
  for(int n=0; n<N; n++){
    addl=true;
    myofs << " " << arr[n];
    count += strlen(arr[n]);
    if(count>wd2)
    { 
      myofs << endl;
      count=0;
      addl=false;
    }
  }
  if(addl) myofs << endl;
  return 0;
}
int fout(int* ia, char* arr[], int N, char* comment, int wd1=12, int wd2=128)
{
  int addl=true;
  int count=0;
  myofs << endl << comment << endl;
  for(int n=0; n<N; n++){
    addl=true;
    myofs << " [" << ia[n] << "]=" << arr[n];
    count += (6+strlen(arr[n]));
    if(count>wd2)
    { 
      myofs << endl;
      count=0;
      addl=false;
    }
  }
  if(addl) myofs << endl;
  return 0;
}
typedef bool BFII(int, int);

int srt(int* arr, int N, BFII f)
{
  int tmp, count=0;
  for(int n=0; n<N-1; n++) 
    for(int m=n+1; m<N; m++){
      if(f(arr[n], arr[m]))continue;
      tmp=arr[n];
      arr[n]=arr[m];
      arr[m]=tmp;
      count++;
  }
  return count;
}
int srt(char* arr[], int N, BFCC f)
{
  char buf[128], count=0;
  for(int n=0; n<N-1; n++) 
    for(int m=n+1; m<N; m++){
      if(f(arr[n], arr[m]))continue;
      strcpy(buf, arr[n]);
      delete[] arr[n];
      arr[n]=new char[strlen(arr[m])+1];
      strcpy(arr[n], arr[m]);
      delete[] arr[m];
      arr[m]=new char[strlen(buf)+1];
      strcpy(arr[m], buf);
      count++;
  }
  return count;
}
int srt(int* ia, char* ca[], int N, BFII f)
{
  char buf[128]; 
  int count=0, n1;
  for(int n=0; n<N-1; n++) 
    for(int m=n+1; m<N; m++){
      if(f(ia[n], ia[m]))continue;
      strcpy(buf, ca[n]);
      delete[] ca[n];
      ca[n]=new char[strlen(ca[m])+1];
      strcpy(ca[n], ca[m]);
      delete[] ca[m];
      ca[m]=new char[strlen(buf)+1];
      strcpy(ca[m], buf);
      n1=ia[n]; ia[n]=ia[m]; ia[m]=n1;
      count++;
  }
  return count;
}
bool fsiia(int n1, int n2){
  if(n1<n2) return true;
  return false;
}
bool fsiib(int n1, int n2){
  int n1a = n1%10;
  int n1b = ((n1-n1a)%100)/10;
  int n1c = (n1-n1a-10*n1b)/100;
  int n2a = n2%10;
  int n2b = ((n2-n2a)%100)/10;
  int n2c = (n2-n2a-10*n2b)/100;
  if(n1a+n1b+n1c>n2a+n2b+n2c) return true;
  if(n1b+n1c>n2b+n2c) return true;
  if(n1c>n2c) return true;
  return false;
}
bool fscca(char* txt1, char* txt2){
  if(strlen(txt1)<strlen(txt2)) return true;
  return false;
}
bool fsccb(char* txt1, char* txt2){
  if(int(txt1[0])<int(txt2[0])) return true;
  if(strlen(txt1)<3 || strlen(txt2)<3) return false;
  if(int(txt1[1])<int(txt2[1])) return true;
  if(strlen(txt1)<4 || strlen(txt2)<4) return false;
  return false;
}
